SystemOrganization addCategory: 'DeliGemstone'!

!DLAdminDeadlineZipComp methodsFor: '*deligemstone-zipping' stamp: 'topa 01/02/2012 13:54'!
createZipFile	
	
	| stream |
	stream := RWBinaryOrTextStream on: (ByteArray new: 1000).
	stream binary.
	ZipArchive new
		addTree: self baseDirectory, self zipDirectoryPath 
		match: [:e | true];
		writeTo: stream.
	^ stream contents.! !

!DLMail methodsFor: '*deligemstone-mailing' stamp: 'tfel 01/02/2012 17:03'!
sendMail
	
	"self receivers ifNotNilDo: [:recvs | | message |
		message := WAEmailMessage 
			from: self sender
			toAll: recvs
			subject: self subject.
		message headerAt: 'Content-Type' put: 'text/html;charset=UTF-8'.
		message body: self text.
		message send]."! !

!DLModel methodsFor: '*deligemstone-saving' stamp: 'TimFelgentreff 01/12/2011 02:53'!
smalltalkDependentSaveStrategy
	"GemStone has commits around each request"! !

!ZipArchive methodsFor: '*deligemstone-zipping' stamp: 'TimFelgentreff 01/14/2011 00:58'!
addTree: aFileNameOrDirectory match: aBlock
	| nameSize |	
	nameSize := aFileNameOrDirectory isString
		ifTrue: [aFileNameOrDirectory size]
		ifFalse: [aFileNameOrDirectory pathName size].	
	^ self	
		addTree: aFileNameOrDirectory
		removingFirstCharacters: nameSize + 1
		match: aBlock! !

!ZipArchive methodsFor: '*deligemstone-zipping' stamp: 'topa 01/02/2012 13:40'!
addTree: aFileNameOrDirectory removingFirstCharacters: n match: aBlock
	| dir fullPath relativePath |
	dir := (aFileNameOrDirectory isString)
		ifTrue: [ ServerFileDirectory on: aFileNameOrDirectory ]
		ifFalse: [ aFileNameOrDirectory ].
	fullPath := dir pathName, dir slash.
	relativePath := fullPath copyFrom: n + 1 to: fullPath size.
	(dir entries select: [ :entry | aBlock value: entry])	
		do: [ :ea || fullName |
			fullName := fullPath, ea name.
			ea isDirectory "Directories aren't written in Zip"
				ifTrue: [ self addTree: fullName removingFirstCharacters: n match: aBlock]
				ifFalse: [ | member |
					member :=  ZipNewServerFileMember new
						from: fullName;
						localFileName: relativePath, ea name;
						yourself.
					self addMember: member]].! !

!ZipArchive methodsFor: '*deligemstone-zipping' stamp: 'topa 01/02/2012 11:07'!
writeToFileNamed: aFilePath
	
	| fd str |
	fd := ServerFileDirectory default forceNewFileNamed: aFilePath.
	str := RWBinaryOrTextStream on: CharacterCollection new.
	str binary.
	self writeTo: str.
	fd nextPutAll: str contents.
	str close.
	fd flush; close.! !

!DLRootComponent methodsFor: '*deligemstone-initialization' stamp: 'TimFelgentreff 02/10/2011 14:54'!
initialize
	super initialize.
	self session announcer on: DLViewCompReplacement do: (AnnouncerSubscription valuable: [:announcement | self viewComp: announcement component ] subscriber: self).
	self session announcer on: DLLogoutAnnouncement  do: (AnnouncerSubscription valuable: [:announcement | self answer: true. ] subscriber: self).! !

ZipNewFileMember subclass: #ZipNewServerFileMember
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DeliGemstone'!

!ZipNewServerFileMember methodsFor: 'as yet unclassified' stamp: 'topa 01/02/2012 13:40'!
fileDirectoryClass

	^ ServerFileDirectory! !

!ZipNewServerFileMember methodsFor: 'as yet unclassified' stamp: 'topa 01/02/2012 13:52'!
setLastModFileDateTimeFrom: aDateTime

	| dosTime |
	dosTime := aDateTime secondsGmt bitShift: -1.
	dosTime := dosTime + (aDateTime minutesGmt bitShift: 5).
	dosTime := dosTime + (aDateTime hoursGmt bitShift: 11).
	dosTime := dosTime + (aDateTime dayOfMonthGmt bitShift: 16).
	dosTime := dosTime + (aDateTime monthGmt bitShift: 21).
	dosTime := dosTime + (((aDateTime yearGmt) - 1980) bitShift: 25).
	
	lastModFileDateTime := dosTime.! !

!FileDirectory class methodsFor: '*deligemstone-zipping' stamp: 'topa 01/02/2012 13:37'!
readOnlyFileNamed: aFileName

	^ self default readOnlyFileNamed: aFileName! !
